--- old/usr/src/uts/common/io/scsi/adapters/mpt_sas3/mptsas3.c	2014-06-12 17:42:15.393924923 +0100
+++ new/usr/src/uts/common/io/scsi/adapters/mpt_sas3/mptsas3.c	2014-06-12 17:42:15.405774308 +0100
@@ -14123,7 +15842,7 @@
 		if (mdi_prop_update_string_array(*pip, "compatible",
 		    compatible, ncompatible) !=
 		    DDI_PROP_SUCCESS) {
-			mptsas_log(mpt, CE_WARN, "mptsas driver unable to "
+			mptsas_log(mpt, CE_WARN, "unable to "
 			    "create prop for target %d lun %d (COMPATIBLE)",
 			    target, lun);
 			mdi_rtn = MDI_FAILURE;
@@ -14131,7 +15850,7 @@
 		}
 		if (sas_wwn && (mdi_prop_update_string(*pip,
 		    SCSI_ADDR_PROP_TARGET_PORT, wwn_str) != DDI_PROP_SUCCESS)) {
-			mptsas_log(mpt, CE_WARN, "mptsas driver unable to "
+			mptsas_log(mpt, CE_WARN, "unable to "
 			    "create prop for target %d lun %d "
 			    "(target-port)", target, lun);
 			mdi_rtn = MDI_FAILURE;
@@ -14141,7 +15860,7 @@
 			/*
 			 * Direct attached SATA device without DeviceName
 			 */
-			mptsas_log(mpt, CE_WARN, "mptsas driver unable to "
+			mptsas_log(mpt, CE_WARN, "unable to "
 			    "create prop for SAS target %d lun %d "
 			    "(sata-phy)", target, lun);
 			mdi_rtn = MDI_FAILURE;
@@ -14154,7 +15873,7 @@
 		    (uint32_t)ptgt->m_devhdl;
 		rval = mptsas_get_sas_device_page0(mpt, page_address,
 		    &dev_hdl, &dev_sas_wwn, &dev_info, &physport,
-		    &phy_id, &pdev_hdl, &bay_num, &enclosure);
+		    &phy_id, &pdev_hdl, &bay_num, &enclosure, &io_flags);
 		if (rval != DDI_SUCCESS) {
 			mutex_exit(&mpt->m_mutex);
 			mptsas_log(mpt, CE_WARN, "mptsas unable to get "
@@ -14167,7 +15886,7 @@
 		    MPI2_SAS_DEVICE_PGAD_FORM_MASK) | (uint32_t)pdev_hdl;
 		rval = mptsas_get_sas_device_page0(mpt, page_address,
 		    &dev_hdl, &pdev_sas_wwn, &pdev_info, &physport,
-		    &phy_id, &pdev_hdl, &bay_num, &enclosure);
+		    &phy_id, &pdev_hdl, &bay_num, &enclosure, &io_flags);
 		if (rval != DDI_SUCCESS) {
 			mutex_exit(&mpt->m_mutex);
 			mptsas_log(mpt, CE_WARN, "mptsas unable to get"
@@ -14214,9 +15933,9 @@
 		if (mdi_prop_update_string(*pip,
 		    SCSI_ADDR_PROP_ATTACHED_PORT, pdev_wwn_str) !=
 		    DDI_PROP_SUCCESS) {
-			mptsas_log(mpt, CE_WARN, "mptsas unable to create "
+			mptsas_log(mpt, CE_WARN, "unable to create "
 			    "property for iport attached-port %s (sas_wwn)",
-			    attached_wwn_str);
+			    pdev_wwn_str);
 			mdi_rtn = MDI_FAILURE;
 			goto virt_create_done;
 		}
@@ -14232,7 +15951,7 @@
 
 			if (mdi_pi_pathname_obp_set(*pip, component) !=
 			    DDI_SUCCESS) {
-				mptsas_log(mpt, CE_WARN, "mpt_sas driver "
+				mptsas_log(mpt, CE_WARN,
 				    "unable to set obp-path for object %s",
 				    component);
 				mdi_rtn = MDI_FAILURE;
@@ -14246,7 +15965,7 @@
 			if ((ndi_prop_update_int(DDI_DEV_T_NONE, *lun_dip,
 			    "pm-capable", 1)) !=
 			    DDI_PROP_SUCCESS) {
-				mptsas_log(mpt, CE_WARN, "mptsas driver"
+				mptsas_log(mpt, CE_WARN,
 				    "failed to create pm-capable "
 				    "property, target %d", target);
 				mdi_rtn = MDI_FAILURE;
@@ -14258,7 +15977,7 @@
 		 */
 		if (mdi_prop_update_int(*pip, "phy-num",
 		    ptgt->m_phynum) != DDI_SUCCESS) {
-			mptsas_log(mpt, CE_WARN, "mptsas driver unable to "
+			mptsas_log(mpt, CE_WARN, "unable to "
 			    "create phy-num property for target %d lun %d",
 			    target, lun);
 			mdi_rtn = MDI_FAILURE;
@@ -14287,9 +16006,6 @@
 	if (lun_addr != NULL) {
 		kmem_free(lun_addr, SCSI_MAXNAMELEN);
 	}
-	if (wwn_str != NULL) {
-		kmem_free(wwn_str, MPTSAS_WWN_STRLEN);
-	}
 	if (component != NULL) {
 		kmem_free(component, MAXPATHLEN);
 	}
@@ -14310,9 +16026,8 @@
 	int			ncompatible = 0;
 	int			instance = 0;
 	mptsas_t		*mpt = DIP2MPT(pdip);
-	char			*wwn_str = NULL;
-	char			*component = NULL;
-	char			*attached_wwn_str = NULL;
+	char			wwn_str[MPTSAS_WWN_STRLEN];
+	char			component[MAXPATHLEN];
 	uint8_t			phy = 0xFF;
 	uint64_t		sas_wwn;
 	uint32_t		devinfo;
@@ -14324,7 +16039,7 @@
 	uint8_t			physport;
 	uint8_t			phy_id;
 	uint32_t		page_address;
-	uint16_t		bay_num, enclosure;
+	uint16_t		bay_num, enclosure, io_flags;
 	char			pdev_wwn_str[MPTSAS_WWN_STRLEN];
 	uint32_t		dev_info;
 	int64_t			lun64 = 0;
@@ -14395,7 +16110,6 @@
 		 * devices need to present for MPAPI. If we don't have
 		 * a WWN (e.g. parallel SCSI), don't create the prop.
 		 */
-		wwn_str = kmem_zalloc(MPTSAS_WWN_STRLEN, KM_SLEEP);
 		(void) sprintf(wwn_str, "w%016"PRIx64, sas_wwn);
 		if (sas_wwn && ndi_prop_update_string(DDI_DEV_T_NONE,
 		    *lun_dip, SCSI_ADDR_PROP_TARGET_PORT, wwn_str)
@@ -14461,7 +16175,7 @@
 		rval = mptsas_get_sas_device_page0(mpt, page_address,
 		    &dev_hdl, &dev_sas_wwn, &dev_info,
 		    &physport, &phy_id, &pdev_hdl,
-		    &bay_num, &enclosure);
+		    &bay_num, &enclosure, &io_flags);
 		if (rval != DDI_SUCCESS) {
 			mutex_exit(&mpt->m_mutex);
 			mptsas_log(mpt, CE_WARN, "mptsas unable to get"
@@ -14473,8 +16187,8 @@
 		page_address = (MPI2_SAS_DEVICE_PGAD_FORM_HANDLE &
 		    MPI2_SAS_DEVICE_PGAD_FORM_MASK) | (uint32_t)pdev_hdl;
 		rval = mptsas_get_sas_device_page0(mpt, page_address,
-		    &dev_hdl, &pdev_sas_wwn, &pdev_info,
-		    &physport, &phy_id, &pdev_hdl, &bay_num, &enclosure);
+		    &dev_hdl, &pdev_sas_wwn, &pdev_info, &physport,
+		    &phy_id, &pdev_hdl, &bay_num, &enclosure, &io_flags);
 		if (rval != DDI_SUCCESS) {
 			mutex_exit(&mpt->m_mutex);
 			mptsas_log(mpt, CE_WARN, "mptsas unable to create "
@@ -14524,7 +16238,7 @@
 			mptsas_log(mpt, CE_WARN,
 			    "mptsas unable to create "
 			    "property for iport attached-port %s (sas_wwn)",
-			    attached_wwn_str);
+			    pdev_wwn_str);
 			ndi_rtn = NDI_FAILURE;
 			goto phys_create_done;
 		}
@@ -14563,7 +16277,7 @@
 		instance = ddi_get_instance(mpt->m_dip);
 		if (devinfo & (MPI2_SAS_DEVICE_INFO_SATA_DEVICE |
 		    MPI2_SAS_DEVICE_INFO_ATAPI_DEVICE)) {
-			NDBG2(("mptsas%d: creating pm-capable property, "
+			NDBG2(("mptsas3%d: creating pm-capable property, "
 			    "target %d", instance, target));
 
 			if ((ndi_prop_update_int(DDI_DEV_T_NONE,
@@ -14584,7 +16298,6 @@
 			 */
 			bzero(wwn_str, sizeof (wwn_str));
 			(void) sprintf(wwn_str, "%016"PRIx64, sas_wwn);
-			component = kmem_zalloc(MAXPATHLEN, KM_SLEEP);
 			if (guid) {
 				(void) snprintf(component, MAXPATHLEN,
 				    "disk@w%s,%x", wwn_str, lun);
@@ -14608,7 +16321,7 @@
 			if (ndi_prop_update_int(DDI_DEV_T_NONE,
 			    *lun_dip, "phy-num", ptgt->m_phynum) !=
 			    DDI_PROP_SUCCESS) {
-				mptsas_log(mpt, CE_WARN, "mptsas driver "
+				mptsas_log(mpt, CE_WARN,
 				    "failed to create phy-num property for "
 				    "target %d", target);
 				ndi_rtn = NDI_FAILURE;
@@ -14636,7 +16349,7 @@
 		 * If success set rtn flag, else unwire alloc'd lun
 		 */
 		if (ndi_rtn != NDI_SUCCESS) {
-			NDBG12(("mptsas driver unable to online "
+			NDBG12(("unable to online "
 			    "target %d lun %d", target, lun));
 			ndi_prop_remove_all(*lun_dip);
 			(void) ndi_devi_free(*lun_dip);
@@ -14646,14 +16359,6 @@
 
 	scsi_hba_nodename_compatible_free(nodename, compatible);
 
-	if (wwn_str != NULL) {
-		kmem_free(wwn_str, MPTSAS_WWN_STRLEN);
-	}
-	if (component != NULL) {
-		kmem_free(component, MAXPATHLEN);
-	}
-
-
 	return ((ndi_rtn == NDI_SUCCESS) ? DDI_SUCCESS : DDI_FAILURE);
 }
 
@@ -14724,7 +16429,7 @@
 	char		*iport = NULL;
 	mptsas_phymask_t	phy_mask = 0;
 	uint16_t	attached_devhdl;
-	uint16_t	bay_num, enclosure;
+	uint16_t	bay_num, enclosure, io_flags;
 
 	(void) sprintf(wwn_str, "%"PRIx64, smp_node->m_addr.mta_wwn);
 
@@ -14791,8 +16496,8 @@
 		    MPI2_SAS_DEVICE_PGAD_FORM_MASK) |
 		    (uint32_t)dev_info.m_pdevhdl;
 		rval = mptsas_get_sas_device_page0(mpt, page_address,
-		    &dev_hdl, &sas_wwn, &smp_node->m_pdevinfo,
-		    &physport, &phy_id, &pdev_hdl, &bay_num, &enclosure);
+		    &dev_hdl, &sas_wwn, &smp_node->m_pdevinfo, &physport,
+		    &phy_id, &pdev_hdl, &bay_num, &enclosure, &io_flags);
 		if (rval != DDI_SUCCESS) {
 			mutex_exit(&mpt->m_mutex);
 			mptsas_log(mpt, CE_WARN, "mptsas unable to get "
@@ -14806,7 +16511,8 @@
 		    (uint32_t)dev_info.m_devhdl;
 		rval = mptsas_get_sas_device_page0(mpt, page_address,
 		    &dev_hdl, &smp_sas_wwn, &smp_node->m_deviceinfo,
-		    &physport, &phy_id, &pdev_hdl, &bay_num, &enclosure);
+		    &physport, &phy_id, &pdev_hdl, &bay_num, &enclosure,
+		    &io_flags);
 		if (rval != DDI_SUCCESS) {
 			mutex_exit(&mpt->m_mutex);
 			mptsas_log(mpt, CE_WARN, "mptsas unable to get "
@@ -14960,7 +16666,7 @@
 	uint64_t			wwn;
 	Mpi2SmpPassthroughRequest_t	req;
 	Mpi2SmpPassthroughReply_t	rep;
-	uint32_t			direction = 0;
+	uint8_t				direction = 0;
 	mptsas_t			*mpt;
 	int				ret;
 	uint64_t			tmp64;
@@ -15264,12 +16970,23 @@
 	tmp_tgt->m_qfull_retry_interval =
 	    drv_usectohz(QFULL_RETRY_INTERVAL * 1000);
 	tmp_tgt->m_t_throttle = MAX_THROTTLE;
+	mutex_init(&tmp_tgt->m_t_mutex, NULL, MUTEX_DRIVER, NULL);
+	TAILQ_INIT(&tmp_tgt->m_active_cmdq);
 
 	refhash_insert(mpt->m_targets, tmp_tgt);
 
 	return (tmp_tgt);
 }
 
+static void
+mptsas_smp_target_copy(mptsas_smp_t *src, mptsas_smp_t *dst)
+{
+	dst->m_devhdl = src->m_devhdl;
+	dst->m_deviceinfo = src->m_deviceinfo;
+	dst->m_pdevhdl = src->m_pdevhdl;
+	dst->m_pdevinfo = src->m_pdevinfo;
+}
+
 static mptsas_smp_t *
 mptsas_smp_alloc(mptsas_t *mpt, mptsas_smp_t *data)
 {
@@ -15279,8 +16996,14 @@
 	addr.mta_wwn = data->m_addr.mta_wwn;
 	addr.mta_phymask = data->m_addr.mta_phymask;
 	ret_data = refhash_lookup(mpt->m_smp_targets, &addr);
+	/*
+	 * If there's already a matching SMP target, update its fields
+	 * in place.  Since the address is not changing, it's safe to do
+	 * this.  We cannot just bcopy() here because the structure we've
+	 * been given has invalid hash links.
+	 */
 	if (ret_data != NULL) {
-		bcopy(data, ret_data, sizeof (mptsas_smp_t)); /* XXX - dupl */
+		mptsas_smp_target_copy(data, ret_data);
 		return (ret_data);
 	}
 
@@ -15444,7 +17167,6 @@
 
 	if (ddi_dma_alloc_handle(mpt->m_dip, &dma_attr, DDI_DMA_SLEEP,
 	    NULL, dma_hdp) != DDI_SUCCESS) {
-		dma_hdp = NULL;
 		return (FALSE);
 	}
 
@@ -15452,7 +17174,6 @@
 	    DDI_DMA_CONSISTENT, DDI_DMA_SLEEP, NULL, dma_memp, &alloc_len,
 	    acc_hdp) != DDI_SUCCESS) {
 		ddi_dma_free_handle(dma_hdp);
-		dma_hdp = NULL;
 		return (FALSE);
 	}
 
@@ -15461,7 +17182,6 @@
 	    cookiep, &ncookie) != DDI_DMA_MAPPED) {
 		(void) ddi_dma_mem_free(acc_hdp);
 		ddi_dma_free_handle(dma_hdp);
-		dma_hdp = NULL;
 		return (FALSE);
 	}
 
@@ -15477,5 +17197,4 @@
 	(void) ddi_dma_unbind_handle(*dma_hdp);
 	(void) ddi_dma_mem_free(acc_hdp);
 	ddi_dma_free_handle(dma_hdp);
-	dma_hdp = NULL;
 }
--- old/usr/src/uts/common/io/scsi/adapters/mpt_sas3/mptsas3_hash.c	2014-06-12 17:42:16.716586855 +0100
+++ new/usr/src/uts/common/io/scsi/adapters/mpt_sas3/mptsas3_hash.c	2014-06-12 17:42:16.722123048 +0100
@@ -11,9 +11,10 @@
 
 /*
  * Copyright 2014 Joyent, Inc.  All rights reserved.
+ * Copyright (c) 2014, Tegile Systems Inc. All rights reserved.
  */
 
-#include <sys/scsi/adapters/mpt_sas/mptsas_hash.h>
+#include <sys/scsi/adapters/mpt_sas3/mptsas3_hash.h>
 #include <sys/sysmacros.h>
 #include <sys/types.h>
 #include <sys/kmem.h>
